﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace SimpleSample
{
    public partial class MainPage : ContentPage
    {
        ViewModel viewModel;
        public MainPage()
        {
            InitializeComponent();
            viewModel = new ViewModel();
            this.BindingContext = viewModel;
        }

        private void XAxis_LabelCreated(object sender, Syncfusion.SfChart.XForms.ChartAxisLabelEventArgs e)
        {
            //DateTimeAxis dateTimeAxis = (DateTimeAxis)sender;
            //dateTimeAxis.Minimum = DateTime.Today;
            //dateTimeAxis.Maximum = DateTime.Today.AddHours(23).AddMinutes(59).AddSeconds(59);

            //hiding the end labels
            if (e.LabelContent == "12 AM" || e.LabelContent == "11 PM" || e.LabelContent == "12 am" || e.LabelContent == "11 pm")
            {
                e.LabelStyle = new ChartAxisLabelStyle();
                e.LabelStyle.TextColor = Color.White;
                e.LabelStyle.FontSize = 0.01f;
            }
            if (e.LabelContent == "12 PM" || e.LabelContent == "12 pm")
            {
                e.LabelContent = "Noon";
            }
        }
    }

    public class ViewModel : INotifyPropertyChanged
    {
        public List<Model> AreaSeriesData { get; set; }

        public ViewModel()
        {
            //AreaSeriesData = new ObservableCollection<Model>();

            //Random random = new Random();
            //var dateTime = DateTime.Today;

            //AreaSeriesData.Add(new Model(dateTime, random.Next(0, 30)));
            //for (int i = 0; i < 24; i++)
            //{
            //    dateTime = dateTime.AddHours(1);
            //    AreaSeriesData.Add(new Model(dateTime, random.Next(0, 30)));
            //}

            AreaSeriesData = new List<Model>()
            {
                new Model (new DateTime(2019, 05, 12, 3, 12,0), -2.1 ),
                new Model (new DateTime(2019, 05, 12, 6, 32,0), -2.3 ),
                new Model (new DateTime(2019, 05, 12, 5, 23,0), 5.1 ),
                new Model (new DateTime(2019, 05, 12, 8, 0,0), 5.2 ),
                new Model (new DateTime(2019, 05, 12, 9, 2,0), 2.1 ),
                new Model (new DateTime(2019, 05, 12, 10, 3,0), 2.3 ),
                new Model (new DateTime(2019, 05, 12, 11, 45,0), 5.1 ),
                new Model (new DateTime(2019, 05, 12, 12, 33,0), 5.2 ),
                new Model (new DateTime(2019, 05, 12, 13, 23,0), 5.2 ),
                new Model (new DateTime(2019, 05, 12, 14, 12,0), 5.2 ),
                new Model (new DateTime(2019, 05, 12, 15, 21,0), 5.2 )
            }.OrderBy(data => data.Date).ToList();

        }

        

public event PropertyChangedEventHandler PropertyChanged;
    }

    public class Model
    {
        public DateTime Date { get; set; }

        public double Value { get; set; }
        public Model(DateTime date, double value)
        {
            Date = date;
            Value = value;
        }
    }
}
